/*
 * utility_test.c
 */


//  ======== Includes =======================================================
#include "utility_test.h"

//  ======== GetSizeFromFile ================================================
int GetSizeFromFile( char * filename )
{
	int size;
	FILE *fp;

	if ((fp = fopen(filename,"r"))==NULL)
		{
			printf("GetSizeFromFile: Enable to open file %s \n",filename);
			exit(0);
		}
	fscanf(fp, "%d", &size);			// Size is the number of the first line of  your file
	printf("GetSizeFromFile \n");
	printf("Size = %d \n\n",size);
	fclose(fp);

	return(size);
}

//  ======== GetSignalValueromFile ==========================================
void GetSignalValueFromFile( char * filename, int N, float* signal )
{
	int size;
	FILE *fp;
	int i;
	float val;

	if ((fp = fopen(filename,"r"))==NULL)
		{
			printf("GetSignalValueFromFile: Unable to open the file %s \n", filename);
			exit(1);
		}
	fscanf(fp, "%d", &size);          // Read size of your file
	if (N>size)
	{
		printf("GetSignalValueFromFile: File contain %d value, your value of %d is wrong ! \n", size, N);
		exit(1);
	}
	// printf("GetSignalValueFromFile \n\n");
	for(i=0;i<N;i++)
	{
		fscanf(fp, "%f", &val);        // Read the ime value
		signal[i] =  val;
	}
	fclose(fp);

	return;

}

//  ======== SignalPrintIn ===================================================
void SignalPrintIn(int N, float* signal)
{
	int i;

	printf("SignalPrint: Signal input \n");
	for(i=0; i<N; i++)
	{
		printf("signalin[%d] = %f \n", i, signal[i]);
	}

	return;

}

//  ======== SignalPrintOut =================================================
void SignalPrintOut(int N, float* signal)
{
	int i;

	printf("SignalPrint: Signal output \n");
	for(i=0; i<N; i++)
	{
		printf("signalout[%d] = %f \n", i, signal[i]);
	}

	return;

}

//  ======== SignalAlloc ====================================================
float * SignalAlloc(int N)
{
	float* signal;

	if ((signal = (float *) malloc(N*sizeof(float)))==NULL)
		{
			printf("SignalAlloc: Enable to allocate signal \n");
			exit(1);
		}

	return (signal);
}

void SignalFree(float * signalIn)
{
	free(signalIn);

	return;

}

//  ======== SaveSignalToFile ================================================
void SaveSignalToFile(char * filename,int N, float* signal)
{
	int i;
	FILE *fp;

	if ((fp = fopen(filename,"w"))==NULL)
	{
		printf("SaveSignalToFile: Enable to open file %s \n",filename);
		exit(1);
	}
	// fprintf(fp, "%d \n",N);        // Write size in new file
	for(i=0;i<N;i++)
	{
		fprintf(fp, "%f \n", signal[i]);    //Write the ime value in new file
	}
	fclose(fp);

	return;
}


